require('json')
require('slot')

function card_index() 
	local t = {}
	if (parameters.items == nil or parameters.items == '') then
		json_table(t, 1)
		return
	end
	
	local g = pio:list_card();

	string.gsub(parameters.items,'([0-9]+)', function (j)
		j = tonumber(j)
		if g[j] ~= nil then
			local i = g[j]['state']
			if slot_state_name[tonumber(i)] ~= nil then
				t['V_' .. j] = slot_state_name[tonumber(i)]
			end
		end
	end)

	json_table(t, 1)
end

function card_init() 
	local g = pio:list_card()
	local i = 0
	out('[')

	for i in next, g do
		out (i .. ',')
	end
	out(']')
end

function card_get_infos()
	out('[')
	local card_one = nil
	if (parameters.items == nil or parameters.items == '') then
		out(']')
		return
	end

	local g = pio:list_card();
	local b = slot_info()

	string.gsub(parameters.items,'([0-9]+)', function (j)
		if card_one == nil then
			card_one = 1
		else
			out(', ')
		end

		j = tonumber(j)

		if g[j] ~= nil then 
  			t = g[j]
			i = t['type']
			type_table = b[tostring(i)]
			t['name'] = type_table[2]
			t['num'] = j
			json_table(t, 1)
		end
	end)

	out(']')


end

function card_read(card) 
	local t = {}
	print("1")
	t['state'] = pio:state_card(parameters.card)
	print("2")
	t['info'] = pio:info_card(parameters.card)
	print("3")
	t['stats'] = pio:stats_card(parameters.card)
	print("4")
	json_table(t, 1)
end

function card_ioread(card)
	local i = pio:state_card(parameters.card)
	i['uptime'] = perax:uptime()
	json_table(i, 1)
end
